

'                        RapidQ Icon Editor
' Format... 766 byte, 1 frame, 32x32 pointcols, 16 color, 4 bits/pointcol
'



 $INCLUDE "RAPIDQ.INC"
 $typecheck on


''''''''''''''''''''''''''' Sub Routine Declarations ''''''''''''''''

''''' Transfer icon data between Icon File and the Z() array .....
 Declare Sub Init
 Declare Sub xopen      ' Open file for Hex editing
 Declare Sub xRun       ' common load and run module 
 Declare Sub xRestore   ' Restores image from z()
 Declare Sub xSave      ' Save file in binary
 Declare Sub xNew       ' Create a new icon


''''' Transfer data twix Z() Array and Editing Displays
 Declare Sub xoffset    ' Display address offsets in xoffset
 Declare Sub xHex       ' z() array => ascii hex display
 Declare Sub PostArray    (go, stop)
 Declare Sub xnewZ      ' z() array <= ascii hex display


''''' Manipulates Display objects as Editing
 Declare Sub ScrollChange (sender as QScrollbar) ' Select a color
 Declare Sub xMode      ' toggle between AND & XOR mode
 Declare Sub xpost      ' refresh the display
 Declare Sub ColorMap   ' display color palettes
 Declare Sub XorMap     ' display image pixels
 Declare Sub AndMap     ' display transparent pixels


''''' Mouse Activity
 Declare Sub eOffsetDown     (b%, x%, y%, s%)
 Declare Sub eOffsetUp       (b%, x%, y%, s%)
 Declare Sub eOffsetMove         (x%, y%, s%)

 Declare Sub eHexDown        (b%, x%, y%, s%)
 Declare Sub eHexUp          (b%, x%, y%, s%) 
 Declare Sub eHexMove            (x%, y%, s%)

 Declare Sub displayDown     (b%, x%, y%, s%)
 Declare Sub displayUp       (b%, x%, y%, s%) 
 Declare Sub displayMove         (x%, y%, s%)

 Declare Sub PaletteDown     (b%, x%, y%, s%, sender as QPanel)
 Declare Sub PaletteUp       (b%, x%, y%, s%, sender as QPanel) 
 Declare Sub PaletteMove         (x%, y%, s%, sender as QPanel)

 Declare Sub SelectColorDown (b%, x%, y%, s%, sender as QPanel)
 Declare Sub SelectColorUp   (b%, x%, y%, s%, sender as QPanel) 
 Declare Sub SelectColorMove     (x%, y%, s%, sender as QPanel)

 Declare Sub ActiveDown      (b%, x%, y%, s%, sender as QPanel)
 Declare Sub ActiveUp        (b%, x%, y%, s%, sender as QPanel) 
 Declare Sub ActiveMove          (x%, y%, s%, sender as QPanel)

 Declare Sub Canvasdown      (b%, x%, y%, s%, sender as QCanvas)
 Declare Sub Canvasup        (b%, x%, y%, s%, sender as QCanvas)
 Declare Sub CanvasMove          (x%, y%, s%, sender as QCanvas)

 Declare Sub xtemp


'''''''''''''''''''''''' Assigning memory for variables '''''''''''''''

 Dim N        :  Dim N$    as string : Dim N% as byte
 Dim C        :  Dim C$    as string
 Dim K        :  Dim k$    as string
 Dim msb      :  Dim msb$  as string : Dim msbcol
 Dim lsb      :  Dim lsb$  as string : Dim lsbcol
 Dim temp     :  Dim Temp$ as string :


 Dim Imagex   as integer   ' Relative QImage & QCanvas points
 Dim Imagey   as integer
 Dim CanvasX  as integer
 Dim CanvasY  as integer
 Dim px       as integer   ' Points within Canvas and Image 
 Dim py       as integer
 Dim vx       as integer   ' Visible Points within Hex display 
 Dim vy       as integer
 Dim tx       as integer   ' Transparent Points within Hex display 
 Dim ty       as integer
 Dim txy      as integer
 Dim inx


 Dim FName$   as string    ' ico file name
 Dim z()      as byte      ' binary bytes, variable array
 Dim eoz      as Integer   ' File.size

 Dim CR$        as string    : CR$= chr$(13)
 DIM HX$        as string    : hx$= "0123456789ABCDEF"

 Dim FormColor  as integer   : FormColor = &hD0D0D0
 Dim initcolor  as integer   : initcolor = &hE0E0E0
 Dim ColorTable(0 to 15)
 Dim Flag
 Dim BGR
 Dim WorkAround





''''''''''''''''''''''''''' Objects '''''''''''''''''''''''''''''''


 Dim FileStream as QFileStream  ' Disk File stream  buffer space
 Dim OpenDialog as QOpenDialog  ' file select dialog for input
 Dim SaveDialog as QSaveDialog  ' file select dialog for output


 Dim Font as QFont
     Font.size  = 10
     Font.color = &h000000
     Font.name  = "courier new"

 Dim Form as QForm
     Form.height = 600
     Form.width  = 800
     Form.color  = FormColor


 Dim Image as QCanvas
     Image.parent = Form
     Image.top = 200
     Image.left = 580
     Image.width = 32
     Image.height = 32
     Image.color  = initcolor

 Dim Canvas as QCanvas
     Canvas.parent = Form
     Canvas.top = 300
     Canvas.left = 520
     Canvas.width = 32*8
     Canvas.height = 32*8
     Canvas.color  = initcolor

     Canvas.OnMouseDown = CanvasDown
     Canvas.OnMouseMove = CanvasMove
     Canvas.OnMouseUp   = CanvasUp



 Dim display as QScrollbox
     display.parent        = Form
     display.top           = 40
     display.left          = 5
     display.width         = 485
     display.height        = 520
     display.color         = &He0e0e0
     display.VertTracking  = 1
     display.Vertincrement = 16

     display.OnMouseDown = displayDown
     display.OnMouseMove = displayMove
     display.OnMouseUp   = displayUp





'''''''''''''''''''''''''' Edit Box Displays''''''''''''''''''''''

 Dim eOFFSET as QRichEdit
     eOFFSET.parent         = display
     eOFFSET.top            = 10
     eOFFSET.left           = 10
     eOFFSET.width          = 50
     eOFFSET.height         = 1070
     eOFFSET.wordwrap       = 1       ' 0-don't wrap 1-do wrap
     eOFFSET.alignment      = 2       ' 1-right  2-center 3-left default-1
     eOFFSET.font           = Font
     eOFFSET.hideselection  = 0

     eOFFSET.OnMouseDown    = eOffsetDown
     eOFFSET.OnMouseUp      = eOffsetUp
     eOFFSET.OnMouseMove    = eOffsetMove


 Dim eHEX as QRichEdit
     eHEX.Parent         = display
     eHEX.top            = eOFFSET.top
     eHEX.left           = eOFFSET.left + eOFFSET.width + 15
     eHEX.width          = 390
     eHEX.height         = 1070
     eHEX.wordwrap       = 1
     eHEX.font           = Font
     eHex.hideselection  = 0

     eHex.OnMouseDown    = eHexDown
     eHex.OnMouseUp      = eHexUp
     eHex.OnMouseMove    = eHexMove



''''''''''''''''''''''''''' Control Buttons '''''''''''''''''''''''''


 Dim bOPEN as QButton
     bOPEN.parent  = Form
     bOPEN.caption = "open"
     bOPEN.top     = 10
     bOPEN.left    = 25
     bOPEN.width   = 48
     bOPEN.OnClick = xopen
     bOPEN.showhint= 1
     bOPEN.hint= "Open a File for input and read"

 Dim bSAVE as QButton
     bSAVE.Parent  = Form
     bSAVE.caption = "Save"
     bSAVE.top     = bOPEN.top
     bSAVE.left    = bOPEN.left+bOPEN.width+5
     bSAVE.width   = bOPEN.width
     bSAVE.OnClick = xsave
     bSAVE.showhint= 1
     bSAVE.hint= "Create a File for output and write"


 Dim bNEW as QButton
     bNEW.Parent  = Form
     bNEW.caption = "NEW"
     bNEW.top     = 10
     bNEW.left    = 370
     bNEW.width   = bOPEN.width
     bNEW.OnClick = xNEW
     bNEW.showhint= 1
     bNEW.hint= "Create a File for output and write"


 Dim bRestore as QButton
     brestore.parent   = Form
     brestore.top      = 10
     brestore.left     = 430
     brestore.width    = 60
     brestore.height   = 25
     brestore.showhint = 1
     brestore.hint     = "Reload Display from Z() array"
     brestore.caption  = "Restore"
     brestore.onclick  = xRestore


 Dim Backup as QButton
     Backup.parent   = Form
     Backup.top      = 10
     Backup.left     = 520
     Backup.width    = 60
     Backup.showhint = 1
     Backup.hint     = "Backup Display into Z() array"
     Backup.height   = 25
     Backup.caption  = "Backup"
     Backup.onclick  = xnewZ



 Dim Mode as QButton
     Mode.parent   = Form
     Mode.top      = 10
     Mode.left     = 600
     Mode.width    = 60
     Mode.showhint = 1
     Mode.hint     = "Toggle AND & XOR Mode, transparent or image"
     Mode.height   = 25
     Mode.caption  = "XOR"
     Mode.onclick  = xMode



 Dim bPost as QButton
     bPost.parent   = Form
     bPost.top      = 210
     bPost.left     = 700
     bPost.width    = 32
     bPost.height   = 20
     bPost.showhint = 1
     bPost.hint     = "Refresh the display"
     bPost.caption  = "Post"
     bPost.onclick  = xpost


 Dim bTemp as QButton                   : Dim eTemp as QEdit
     btemp.parent   = Form              :     etemp.parent   = Form
     btemp.top      = 10                :     etemp.top      = 10 
     btemp.left     = 150               :     etemp.left     = bTemp.left+50
     btemp.width    = 45                :     etemp.width    = 150
     btemp.height   = 25                :     etemp.height   = 25
     btemp.showhint = 1                 :     etemp.showhint = 1
     btemp.hint     = "development"     :     etemp.hint     = "development" 
     btemp.caption  = "temp"            :     etemp.text  = "   temp"
     btemp.onclick  = xtemp


''''''''''''''''''''''''''' Color PLalette '''''''''''''''''''''''''

 Dim  PaletteTop  : paletteTop  = 40
 Dim  PaletteLeft : paletteLeft = 520

 Dim  Palette(0 to 15) as QPanel
          For n = 0 to 15
      Palette(n).parent      = Form
      Palette(n).top         = paletteTop  + 40 * int(n/4)
      Palette(n).left        = paletteLeft + 40 * (n mod(4))
      Palette(n).width       = 25
      Palette(n).height      = 20
      Palette(n).color       = initcolor
      Palette(n).showhint    = 1
      Palette(n).hint        = right$(hex$(n),1)

      Palette(n).OnMouseDown = PaletteDown
      Palette(n).OnMouseMove = PaletteMove
      Palette(n).OnMouseUp   = PaletteUp

          Next n


Dim   ActiveColor as QPanel
      ActiveColor.parent     = Form
      ActiveColor.top        = 210
      ActiveColor.left       = 520
      ActiveColor.width      = 32
      ActiveColor.height     = 20
      ActiveColor.color      = initcolor
      ActiveColor.showhint   = 1
      ActiveColor.hint       = "0"
      ActiveColor.color      = initcolor

      ActiveColor.OnMouseDown = ActiveDown
      ActiveColor.OnMouseMove = ActiveMove
      ActiveColor.OnMouseUp   = ActiveUp



 Dim  scrollTop  : scrollTop  = 240
 Dim  scrollLeft : scrollLeft = 520

 Dim  scroll(0 to 2) as QScrollBar
          For n = 0 to 2
      scroll(n).parent   = Form
      scroll(n).top      = scrollTop   + 18*n
      scroll(n).left     = scrollLeft
      scroll(n).width    = 256
      scroll(n).height   = 10
      scroll(n).showhint = 1
      scroll(n).hint     = right$(hex$(n),1)
      scroll(n).max=     = 255
      scroll(n).position = initcolor/(256*256)

      scroll(n).OnChange = ScrollChange
          Next n


Dim   SelectColor as QPanel
      SelectColor.parent      = Form
      SelectColor.top         = 210
      SelectColor.left        = 635
      SelectColor.width       = 32
      SelectColor.height      = 20
      SelectColor.showhint    = 1
      SelectColor.hint        = "Select "
      SelectColor.Color       = initcolor

      SelectColor.OnMouseDown = SelectColorDown
      SelectColor.OnMouseMove = SelectColorMove
      SelectColor.OnMouseUp   = SelectColorUp


 Dim IRIG as QTimer
     irig.interval= 500
     irig.OnTimer = init



      Form.Showmodal
















''''______________________________________________________________________
''''______________________________________________________________________
''''______________________________________________________________________


''''''''''''''''''''' File handling subs '''''''''''''''''

 sub Init
         irig.enabled= 0
      If commandcount > 0 then
         FNAME$ = command$(1)
         xRun
     Else
         eHex.Clear
         eHex.Addstrings "   Click the OPEN Button "
         eHex.Addstrings "          then           "
         eHex.Addstrings "    Select an Icon File  "
     End IF
 end sub




'''' else select the ico file with the open button
 Sub xopen
  If OpenDialog.Execute = 0   Then eoz= 0: exit sub
     FNAME$ = opendialog.filename
     xRun
 end Sub



'''' common load and run module for xDragDrop and xopen
 Sub xRun
         FileStream.Open( FNAME$, fmOpenRead)
         FileStream.LoadArray(z(0),FileStream.Size)
         eoz = FileStream.size-1
         FileStream.close
         xRestore
 end sub


 Sub xRestore
         xoffset
         xhex
      IF eoz <> 765 then showmessage " this is not a 766 byte file"_
         +chr$(13)+"the graphics display will be other"_
         +chr$(13)+"then that of a RapidQ .ico file"
     xpost
 end sub


 Sub xSave
         xnewZ
      If SaveDialog.Execute then
         FileStream.Open(SAVEdialog.filename, fmcreate)
         FileStream.SaveArray(z(),eoz+1)
         FileStream.Close
     End If
 end sub




''''______________  Support Subs For Input __________________________
''''              





''''        Creates address display in left display field

 Sub xoffset
            eOFFSET.Clear :  if eoz=0 then exit sub
            eOFFSET.ReadOnly = 0
            eOFFSET.text = "0000"
            eOFFSET.addstrings "0002"
            eOFFSET.addstrings "0004"
            eOFFSET.addstrings "    "
            eOFFSET.addstrings "0006"
            eOFFSET.addstrings "0007"
            eOFFSET.addstrings "0008"
            eOFFSET.addstrings "0009"
            eOFFSET.addstrings "000A"
            eOFFSET.addstrings "000C"
            eOFFSET.addstrings "000E"
            eOFFSET.addstrings "0012"

            eOFFSET.addstrings "    "
             for n = 22 to 61 step 16
                 n$= right$(hex$(n),4)
                 eOFFSET.addstrings (n$)
            next n

            eOFFSET.addstrings "    "
             for n = 62 to 125 step 16
                 n$= right$(hex$(n),4)
                 eOFFSET.addstrings (n$)
            next n

            eOFFSET.addstrings "    "
             for n = 126 to 637 step 16
                 n$= right$(hex$(n),4)
                 eOFFSET.addstrings (n$)
            next n

            eOFFSET.addstrings "    "
             for n = 638 to 765 step 16
                 n$= right$(hex$(n),4)
                 eOFFSET.addstrings (n$)
            next n
            eOFFSET.ReadOnly = 1
 end sub





           ''''  Posts ascii decimal equivalant from z() to data array
           ''''  Image editing affects the Display without changing z()
           ''''  nested sub (PostArray) posts image bytes to the display
 Sub xHex 
           eHEX.Clear : IF eoz=0 then exit sub
           PostArray (0, 1)
           PostArray (2, 3)
           PostArray (4, 5)     :  eHEX.addstrings " "
           PostArray (6, 6) 
           PostArray (7, 7)
           PostArray (8, 8)
           PostArray (9, 9)
           PostArray (10, 11)
           PostArray (12, 13)
           PostArray (14, 17)
           PostArray (18, 21)   :  eHEX.addstrings " "
           PostArray (22, 61)   :  eHEX.addstrings " "
           PostArray (62, 125)  :  eHEX.addstrings " "
           PostArray (126, 637) :  eHEX.addstrings " "
           PostArray (638, 765)
 end sub
     sub PostArray (go, stop)   '''' one line of text in the display
                n$= ""
            for n = go to stop
                n$= n$+ Right$(hex$(z(n)),2)+" "
           next n
         eHEX.addstrings n$
     end Sub



      ''''   Converts ascii hex in display to z() array via ascii string
      ''''   Transfers edited data back to z() array to save to file
 sub xnewZ
           n= 0: c$= ucase$(eHEX.text)
      FOR  C= 1 to len(c$)
            msb$= mid$(c$,c,1)
         IF msb$> " " then 
            msb = instr(hx$,msb$)-1
              lsb$= mid$(c$,c+1,1)
              lsb = instr(hx$,Lsb$)-1
            z(n)= msb*16+lsb
            c= c+1
            n= n+1
     END IF
     NEXT C
       eoz= n-1
 end sub




         ''''      Sum the GBR values and color the selector panel
         ''''   Activated with the QScrollbar() OnChange inrups
         ''  each position represents one of the selected colors

 Sub ScrollChange (sender as QScrollbar)
           n= scroll(0).position              ' RED
        n= n+ scroll(1).position * 256        ' Blue
        n= n+ scroll(2).position * 256 * 256  ' Green
     SelectColor.color = n                    ' display the color
 end Sub



 Sub xMode
         IF mode.caption= "XOR" then
            mode.caption= "AND"
       ELSE
            mode.caption= "XOR"
     End IF
 end Sub




'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


''''______________________________________________________________________
''''____________________ xPost brings it all together ____________________
''''______________________________________________________________________




''''''''''''''''______________ Editing Modules ________________
           ''''' Display the Editing (right) side of the Form
           ''''' Z() remains unchanged. The eHex display will


     ''  This is a biggie. A lot of houskeeping need be done here.
     ''  When a change occurs during editing, then compatibility must
     ''  be maintained with the editing display and the hex data display.

 Sub xPost
         ColorMap
         XorMap
         AndMap
         ehex.sellength = 0
         ehex.hideselection = 0
 end Sub



 Sub ColorMap
         ''   _______________  16 COLOR PALETTE  _______________
           ''''' paint QPanels() from the ascii eHex display data
           '''''     store the colors in the colortable()

                eHex.selstart  = 219: ehex.sellength = 191: c$= eHex.seltext
            n= 0
       FOR  C= 0 to len(c$) step 12
               msb$= mid$(c$,c+1,1) : msb = instr(hx$,msb$)-1
               lsb$= mid$(c$,c+2,1) : lsb = instr(hx$,Lsb$)-1
                  k= ((msb*16)+lsb) * 256 * 256
               msb$= mid$(c$,c+4,1) : msb = instr(hx$,msb$)-1
               lsb$= mid$(c$,c+5,1) : lsb = instr(hx$,Lsb$)-1
                  k=k+ ((msb*16)+lsb) * 256
               msb$= mid$(c$,c+7,1) : msb = instr(hx$,msb$)-1
               lsb$= mid$(c$,c+8,1) : lsb = instr(hx$,Lsb$)-1
                  k=k+ ((msb*16)+lsb)
               colortable(n)= k
               palette(n).color = k
            n= n+1
       NEXT C

        '' ensure the active color is one of the color palettes colors.
        '' make the active color be palette 0 if it isn't.

                 Flag= 0
          For n= 15 to 1 step -1
              IF palette(n).hint = Activecolor.hint then flag= 3
         Next n
              IF flag <> 3 then
                 flag = 0 
                 Activecolor.color = palette(0).color
                 Activecolor.hint  = palette(0).hint
          End IF
 end Sub





 Sub XorMap
         '''''  display each pixel using the color table

         '' Capture the entire XOR data into C$
         '' 16 bytes= 32 ascii +16 spaces *32 lines= 1536 Ascii
         '' px and py step through the images rows and columns
         '' QImage values are one pixel apart
         '' QCanvas values are 8 pixels square



         '' __________  XOR Display Memory MAP ___________

         n=1536                    ' begin with C$s las byte
           eHex.selstart= 416      ' select first hex color nibble
           eHex.sellength= n       ' select the entire image
           C$= eHex.seltext        ' capture the entire set of nibbles
           ehex.sellength = 0      ' remove the highlighting.


         '''''  Nexted for next loops for relative posts to images
         '' PY from top row to the bottom row of each image
         '' PX from the right to the left for each row 

     For py= 0 to 31         : ImageY= py     : CanvasY= py * 8
     For px= 15 to 0 step -1 : ImageX= px * 2 : CanvasX= px * 2 * 8


          ''''  get both pixel color nibbles from each hex byte
                 lsb$= mid$(c$,n-1,1) : lsb = instr(hx$,Lsb$)-1
                 msb$= mid$(c$,n-2,1) : msb = instr(hx$,msb$)-1


          ''''  get both colors from color table
     msbcol= colortable(msb)
     lsbcol= colortable(lsb)


          ''''  post two colors in the icon image
          Image.pSet (Imagex   ,Imagey ,msbcol)
          Image.pSet (Imagex+1 ,Imagey ,lsbcol)

          ''''  post two colors in the Canvas image
          Canvas.fillrect (CanvasX   ,CanvasY ,CanvasX+8  ,CanvasY+8 ,msbcol)
          Canvas.fillrect (CanvasX+8 ,CanvasY ,CanvasX+16 ,CanvasY+8 ,lsbcol)


          ''''  post backwards for the inverted bitmap image
          ''''     get bytes from bottom to top
          n=n-3    '' count back 3 bytes in the hex data display
         Next px   '' next column in the row (right to left)
         Next py   '' next row of the image (top to bottom)
 end Sub







''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


 Sub AndMap
         '''''  display each pixel as Transparent or not

         '' Step through the QImage and QCanvas display the
         '' same way as done with the XOR MAP but handle the
         '' individual nibbles in their own way



         '' __________  AND Display Memory MAP ___________

                    ' Copy XOR MAP into k$ from eHex
        eHex.selstart= 1957:  eHex.sellength= 384: K$= eHex.seltext


                    ' Copy to C$ without the spaces
             ' variable INX is the number of nibbles to be serviced
           c$=""
       for n= 1 to len(k$): n$= mid$(k$,n,1): if n$ <> " " then c$=c$+n$
           next n : inx= len(c$)
 

         '''''  Nexted for next loops for relative posts to images
         '' PY from top row to the bottom row of each image
         '' PX from the right to the left, 4 pixels at a time
     For py= 0 to 31         : ImageY= py  : CanvasY= Imagey * 8
     For px= 28 to 0 step -4 : ImageX= px  : CanvasX= Imagex * 8


          ''''  service a 4 bit nibble, 1 character in C$
       n$= mid$(c$,inx,1): n$= right$("0000"+bin$(instr(hx$,n$)-1),4)
     IF n$<>"0000" then
        for c= 0 to 3
         IF mid$(n$,c+1,1)="1" then
            Image.pSet (Imagex+c, Imagey ,FormColor)
            Canvas.fillrect (CanvasX+(8*c), CanvasY, CanvasX+(8*c)+8, CanvasY+8, FormColor)
       end IF
       next c
    End IF

          ''''  post backwards for the inverted bitmap image
            inx= inx-1   '' count nibbles back through c$
            Next px      '' next column in the row (right to left)
            Next py      '' next row of the image (top to bottom)
 end Sub



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''








      '''''__________ Creates a new target image to Edit ________

 sub xNEW

        c$= "00 00 " + cr$
     c$=c$+ "01 00 " + cr$
     c$=c$+ "01 00 " + cr$
     c$=c$+ cr$

     c$=c$+ "20 " + cr$
     c$=c$+ "20 " + cr$
     c$=c$+ "10 " + cr$
     c$=c$+ "00 " + cr$
     c$=c$+ "00 00 " + cr$
     c$=c$+ "00 00 " + cr$
     c$=c$+ "E8 02 00 00 " + cr$
     c$=c$+ "16 00 00 00 " + cr$
     c$=c$+ cr$

     c$=c$+ "28 00 00 00 20 00 00 00 40 00 00 00 01 00 04 00 " +cr$
     c$=c$+ "00 00 00 00 80 02 00 00 00 00 00 00 00 00 00 00 " +cr$
     c$=c$+ "00 00 00 00 00 00 00 00 " +cr$
     c$=c$+ cr$

     c$=c$+ "00 00 00 00 00 00 80 00 00 80 00 00 80 80 80 00 "
     c$=c$+ "00 55 99 00 00 88 CC 00 80 80 00 00 A0 A0 A0 00 "
     c$=c$+ "FF FF 00 00 FF 00 FF 00 00 FF FF 00 C0 C0 C0 00 "
     c$=c$+ "00 00 FF 00 00 FF 00 00 FF 00 00 00 FF FF FF 00 "
     c$=c$+ cr$

     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "FF 11 22 33 44 55 66 77 88 99 AA BB CC DD EE FF "
     c$=c$+ "FF 11 22 33 44 55 66 77 88 99 AA BB CC DD EE FF "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 55 44 00 00 00 00 44 50 00 00 55 00 00 00 "
     c$=c$+ "00 00 05 44 00 00 00 04 55 00 00 44 45 00 00 00 "
     c$=c$+ "00 00 05 54 40 00 00 44 50 00 04 45 00 00 00 00 "
     c$=c$+ "00 00 00 54 40 00 00 45 50 05 44 55 00 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 04 45 00 44 44 45 50 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 04 55 00 45 00 45 50 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 44 50 04 45 00 44 55 00 00 00 "
     c$=c$+ "00 00 00 55 45 00 45 50 04 55 00 54 55 00 00 00 "
     c$=c$+ "00 00 00 55 44 44 45 00 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 00 55 45 54 45 00 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 44 50 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 04 50 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 00 55 40 00 04 50 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 00 54 40 00 04 50 04 55 00 04 55 00 00 00 "
     c$=c$+ "00 00 05 54 44 00 04 50 04 55 50 44 55 00 00 00 "
     c$=c$+ "00 00 55 44 54 44 45 50 05 45 50 45 55 00 00 00 "
     c$=c$+ "00 05 54 45 55 44 45 50 05 44 44 45 50 00 00 00 "
     c$=c$+ "00 05 55 55 55 55 55 00 00 55 55 55 50 00 00 00 "
     c$=c$+ "00 05 55 00 55 55 50 00 00 55 55 55 00 00 00 00 "
     c$=c$+ "00 05 50 00 05 55 00 00 00 05 55 50 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ cr$

     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ "00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 "
     c$=c$+ cr$

     eHex.clear           ' clear the hex display
     eHex.addstrings c$   ' post the new icon data
     xNewz                ' load the z(array)
     xrestore             ' post it as a RESTORE image
 End Sub




''''______________________________________________________________________
''''______________________________________________________________________
''''   Mouse Activity  Ups, Downs and Moves





      '''''______________ Offset Edit Display control _____________


 Sub eOffsetDown (b%, x%, y%, s%)
                 n= eOffSet.wherey
                n$= "error this statement should never be seen"
   if  n=0 then n$= " 00 word Reserved, always zero"
   if  n=1 then n$= " 02 word Resource Type 0-cursor  1-icon"
   if  n=2 then n$= " 04 word Number of images"

   if  n= 3  then n$= " STRUCTURE [0006 - 0015] Icon structure information"
   if  n= 4  then n$= " 06 byte Image width  in pixels. hex 20= 32 decimal"
   if  n= 5  then n$= " 07 byte Image height in pixels"
   if  n= 6  then n$= " 08 byte Number of color palettes"
   if  n= 7  then n$= " 09 byte Reserved, always zero"
   if  n= 8  then n$= " 0A word Number of color planes"
   if  n= 9  then n$= " 0C word Bits per pixel. four by default"
   if  n= 10 then n$= " 0E dword image Byte count= E8 02 (little endian)= 744"
   if  n= 11 then n$= " 12 dword image location= 22 + 744= 766 bytes this file"

   if  n= 12 then n$= " ICONDIR [0012 - 003D] tweeks for bitmap thingies"
   if  n= 13 then n$= " 16 16 bytes"
   if  n= 14 then n$= " 26 16 bytes"
   if  n= 15 then n$= " 36  8 bytes"

   if  n= 16 then n$= " RGBQUAD [003E - 007D] 16 RGB Quads, 4 bytes each"
   if  n= 17 then n$= " 3E palette 0-3"
   if  n= 18 then n$= " 4E palette 4-7"
   if  n= 19 then n$= " 5E palette 8-B"
   if  n= 20 then n$= " 6E palette C-F"

   if  n= 21 then n$= " XOR MAP [007E - 027D] 16 bytes, 32 nibbles, one per pixel"
   if  n= 22 then n$= " [007E 8D] Bottom line of the image, 32 nibbles"
   if  n> 22 and  n< 53 then n$= "each nibble references one of the color palettes"
   if  n= 53 then n$= " [026E 27D] Top line of the image, 32 nibbles"
   if  n= 54 then n$= " AND MAP [027E -2FD] one bit per pixel, 1= transparent"
   if  n> 54 and  n< 63 then n$= "each nibble defines four pixel states, 1 or 0.
      showmessage n$
  ''' form.caption = n$
 End Sub


 Sub eOffsetUp       (b%, x%, y%, s%)
 End Sub 


 Sub eOffsetMove         (x%, y%, s%)
 End Sub








      '''''______________Color select QPanel control _____________

 Sub SelectColorDown (b%, x%, y%, s%, sender as QPanel)
       BGR = sender.color
       Flag = 1
 end sub

 Sub SelectColorUp (b%, x%, y%, s%, sender as QPanel)
 end sub

 Sub SelectColorMove (x%, y%, s%, sender as QPanel)
 end sub






      '''''______________Color Palettes QPanel control ___________

 Sub PaletteDown   (b%, x%, y%, s%, sender as QPanel)
         ActiveColor.color = sender.color
         ActiveColor.hint  = sender.hint
  End sub 

 Sub PaletteMove (b%, x%, y%, s%, sender as QPanel)

     '' This will highlight to bytes for the selected palette
         c$= sender.hint        '''  get hex number of palette
          c= instr(hx$,c$)-1     ''' c= decimal of palette number
           eHex.selstart  = 219 + 12 * c
            eHex.sellength = 8
 
     '' The flag is 1 if drag & drop is selected. color is in BGR
         If Flag= 1 then
            Flag= 0                   ''  disarm the drag flag
               sender.color  = BGR    ''  put BGR into palette
               colortable(c) = BGR    ''  put BGR into color table

     '' Put color value into hex display. Sel length and start already set
            c$= hex$(bgr)          ''  build ADE for hex display
            n$= mid$(c$,3,2) +" "_
              + mid$(c$,5,2) +" "_
              + mid$(c$,7,2)
                eHex.seltext   = n$    ''  and post it

     '' Change active color if is selecting this palette
         If ActiveColor.hint = sender.hint then ActiveColor.Color = BGR
     End If
 end sub

 Sub PaletteUp   (b%, x%, y%, s%, sender as QPanel)
 End sub





      '''''_______________Active color QPanel control _________________

 Sub ActiveDown (b%, x%, y%, s%, sender as QPanel)
 end sub

 Sub ActiveUp (b%, x%, y%, s%, sender as QPanel)
 end sub

 Sub ActiveMove (x%, y%, s%, sender as QPanel)
 end sub





      '''''_____________ QCanvas display control _______________

  '' Highlights eHex SelStart for the Canvas cursor position PX + PY
  '' convert x% and y% position to character number in the hex display
  ''       X% , Y% are pixel positions on the canvas
  ''   int(X% / 8) = start of each of 32 pixel squares on the canvas. 
  ''  +int(X% / 16)  skips every third character in the row
  ''     368 th character is the beginning of the 1st AND map row - one row
  ''     1909th character is the beginning of the 1st XOR map row - one row
  ''     48 pixels is the character count of each row in the eHex display
  ''     int(y% mod(32) which of the 4 canvas lines per eHex line is selected 

 Sub CanvasMove (x%,y%,s%)      '' Highlights the pixel value in hex display
     vx = int(x%/8) + int(x%/16) 
     vy = 368 + (48* (32- int(y%/8)))
     tx  = int(x%/(4*8))*1.5             '' dx= f(x%)
     txy = (3-(((y%-4)/8)mod(4)))*12     '' dx= f(y%)
     ty  = 1909 + (48*(8-int(y%/32)))    '' dy= f(y%)
     IF mode.caption = "XOR" then  ehex.selstart  = vy + vx
     IF mode.caption = "AND" then  ehex.selstart  = ty + tx + txy
        ehex.sellength = 1
 End Sub


 Sub Canvasup        (b%, x%, y%, s%, sender as QCanvas)
 End Sub


     ''  SelStart and SelLength are already set from OnCanvasMove
 Sub Canvasdown (b%, x%, y%, s%, sender as QCanvas)
      IF mode.caption = "XOR" then
         eHex.seltext= Activecolor.hint
  End IF
      IF mode.caption = "AND" then
         n = instr(hx$,ehex.seltext)-1
         k = 2^(3-int(x%/8)mod(4))
         n$= right$(hex$((n xor k)),1)
         eHex.seltext= n$
  End IF
         ColorMap
         XorMap
         AndMap
 END SUB





      '''''______________ ScrollBox control _____________

 Sub displayDown     (b%, x%, y%, s%)
 End Sub

 Sub displayUp       (b%, x%, y%, s%)
 End Sub

 Sub displayMove         (x%, y%, s%)
 End Sub




      '''''______________ Hex Edit Display control _____________

 Sub eHexDown (b%, x%, y%, s%)
     Display.VertPosition= workaround
 End Sub

 Sub eHexUp       (b%, x%, y%, s%)
 End Sub 

 Sub eHexMove         (x%, y%, s%)
     workaround= Display.VertPosition
 End Sub






''''______________________________________________________________________
''''______________________________________________________________________
''''_______________ diagnostic and development aid___________

       ''''  Easy access to temp button and edit box for testing

  Sub xtemp

  end sub


'''                  ___________ kalos ________

